#ifndef Diff_h
#define Diff_h
#include <BK/Struct.h>
#include <BK/Vypocty/XYDS.h>

#define Px 1
#define Py 2
#define Kx 3
#define Ky 4
double DiffD( Bod P, Bod K, int x )
{ if( x==Px ) return (P.x-K.x) / GetD(P,K);
  if( x==Py ) return (P.y-K.y) / GetD(P,K);
  if( x==Kx ) return (K.x-P.x) / GetD(P,K);
  if( x==Ky ) return (K.y-P.y) / GetD(P,K);
  return 0;
}

double DiffS( Bod P, Bod K, int x, int mira=GRA )
{ double c = K.y-P.y;
  double j = P.x-K.x;
  double out;
  if( x==Px ) out =  c / (j*j) / (c*c/(j*j)+1);
  if( x==Py ) out =  1 /  j    / (c*c/(j*j)+1);
  if( x==Kx ) out = -c / (j*j) / (c*c/(j*j)+1);
  if( x==Ky ) out = -1 /  j    / (c*c/(j*j)+1);
  if( mira==RAD ) return out;
  if( mira==DEG ) return out*180/M_PI;
  if( mira==GRA ) return out*200/M_PI;
}

#define Lx 1
#define Ly 2
#define Vx 3
#define Vy 4
#define Rx 5
#define Ry 6
double DiffU( Bod L, Bod V, Bod R, int x, int mira=GRA )
{ if( x==Lx ) return -DiffS(V,L,Kx,mira);
  if( x==Ly ) return -DiffS(V,L,Ky,mira);
  if( x==Vx ) return DiffS(V,R,Px,mira)-DiffS(V,L,Px,mira);
  if( x==Vy ) return DiffS(V,R,Py,mira)-DiffS(V,L,Py,mira);
  if( x==Rx ) return DiffS(V,R,Kx,mira);
  if( x==Ry ) return DiffS(V,R,Ky,mira);
  return 0;
}

#endif
